﻿#include <Date.au3>
#include "SerialComm.au3"

Global $sSerialPort = 'COM13', $sSerialBaud = 19200
Global $aRows[] = [_Now(), 'Neue Nachricht von', '"Oscar"', '"Weckzeit erreicht!"']
;~ Global $aRows[] = ['12345678901234567890', '22345678901234567890', '32345678901234567890', '42345678901234567890']

Global $iTimer = TimerInit()
_LCD_SendMail($sSerialPort, $sSerialBaud, $aRows)
ConsoleWrite(TimerDiff($iTimer) & @CR)

Func _LCD_SendMail(ByRef $sSerialPort, ByRef $sSerialBaud, ByRef $aData)
	Local $hPort = _SerialComm_OpenPort($sSerialPort, 1000, $sSerialBaud) ; den seriellen Port oeffnen
	If @error Then Exit ConsoleWrite('Fehler Nr.: ' & @error & @CR)
	_SerialComm_SendData($hPort, Chr(2)) ; Anfang der Uebertragung an den Arduino senden
	For $i = 0 To UBound($aData) - 1
		_SerialComm_SendData($hPort, StringFormat('%-20.20s\n', $aData[$i])) ; Zeile an den Arduino senden
	Next
	_SerialComm_SendData($hPort, Chr(4)) ; Ende der Uebertragung an den Arduino senden
	_SerialComm_ClosePort($hPort)
EndFunc

