﻿#include <ComboConstants.au3>
#include <Date.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

#include "SerialComm.au3"

Global $aComPort, $sComPortNames, $aRows[4], $sSerialPort, $sSerialBaud = 115200, $sRet, $iTimer, $iDiff
$aComPort = _GetComPortNames() ; die vorhandenen COM-Ports einlesen
If @error Then Exit
$sSerialPort = $aComPort[0] ; den ersten Eintrag als Standard auswaehlen
For $sAdd In $aComPort
	$sComPortNames &= $sAdd & '|'
Next
$sComPortNames = StringTrimRight($sComPortNames, 1)

Global $hGui = GUICreate('News-Display v1.1', 330, 480)
GUISetBkColor(0xCFCFCF, $hGui)
GUISetFont(9, 400, 0, 'Verdana')
GUICtrlCreateGroup('Arduino COM-Port auswählen', 10, 10, 310, 65)
Global $idComPort = GUICtrlCreateCombo('', 25, 35, 280, 30, $CBS_DROPDOWNLIST)
GUICtrlSetData(-1, $sComPortNames, $sSerialPort)
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Arduino Baudrate auswählen', 10, 80, 310, 65)
Global $idComBaud = GUICtrlCreateCombo('', 25, 105, 280, 30, $CBS_DROPDOWNLIST)
GUICtrlSetData(-1, '9600 Baud|19200 Baud|38400 Baud|57600 Baud|115200 Baud|230400 Baud|2000000 Baud', '115200 Baud')
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Datum / Zeit', 40, 160, 240, 60)
Global $idDate = GUICtrlCreateLabel(_Now(), 60, 185, 210, 25)
GUICtrlSetFont(-1, 12, 400, 0, 'Courier New')
GUICtrlSetLimit(-1, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Absender (max. 20 Zeichen)', 40, 230, 240, 65)
Global $idSender = GUICtrlCreateInput(@UserName, 55, 255, 210, 25)
GUICtrlSetFont(-1, 12, 400, 0, 'Courier New')
GUICtrlSetLimit(-1, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Nachricht (2 x 20 Zeichen)', 40, 300, 240, 105)
Global $idRow1 = GUICtrlCreateInput('', 55, 325, 210, 25)
GUICtrlSetFont(-1, 12, 400, 0, 'Courier New')
GUICtrlSetLimit(-1, 20)
Global $idRow2 = GUICtrlCreateInput('', 55, 365, 210, 25)
GUICtrlSetFont(-1, 12, 400, 0, 'Courier New')
GUICtrlSetLimit(-1, 20)
GUICtrlCreateGroup('', -99, -99, 1, 1)

Global $idSend = GUICtrlCreateButton('Absenden', 55, 420, 210, 28)
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')

Global $idStatus = GUICtrlCreateLabel('', 0, 460, 330, 20, Default, $WS_EX_STATICEDGE)
GUICtrlSetFont(-1, 12, 400, 0, 'Arial')
GUICtrlSetBkColor(-1, 0xEEEEEE)

GUISetState()
While True
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			Exit
		Case $idComPort
			$sSerialPort = '\\.\\' & StringRegExpReplace(GUICtrlRead($idComPort), '.+\((.+?)\).*', '$1')
		Case $idComBaud
			$sSerialBaud = Number(StringTrimRight(GUICtrlRead($idComBaud), 5))
		Case $idSend
			GUICtrlSetState($idSend, $GUI_HIDE)
			$aRows[0] = GUICtrlRead($idDate)
			$aRows[1] = GUICtrlRead($idSender)
			$aRows[2] = GUICtrlRead($idRow1)
			$aRows[3] = GUICtrlRead($idRow2)
			$iTimer = TimerInit()
			$sRet = _LCD_SendMail($sSerialPort, $sSerialBaud, $aRows)
			$iDiff = TimerDiff($iTimer)
			GUICtrlSetData($idStatus, StringFormat('Status: %s  (%i ms)', ($sRet = 'ok' ? 'Ok!' : ($sRet = '--' ? 'Speicher voll' : 'Übertragungsfehler!')), $iDiff))
			GUICtrlSetState($idSend, $GUI_SHOW)
	EndSwitch
	If _Now() <> GUICtrlRead($idDate) Then GUICtrlSetData($idDate, _Now())
WEnd

Func _LCD_SendMail(ByRef $sSerialPort, ByRef $sSerialBaud, ByRef $aData)
	Local $tReceiveData = DllStructCreate('char[2]') ; Puffer mit 2 Char erstellen, weil der Arduino 2 Zeichen zurueckschickt: "ok"
	Local $hPort = _SerialComm_OpenPort($sSerialPort, 1000, $sSerialBaud) ; den seriellen Port oeffnen
	If @error Then Exit ConsoleWrite('Fehler Nr.: ' & @error & @CR)
	_SerialComm_SendData($hPort, Chr(2)) ; Anfang der Uebertragung an den Arduino senden
	For $i = 0 To UBound($aData) - 1
		_SerialComm_SendData($hPort, StringFormat('%-20.20s\n', $aData[$i])) ; Zeile an den Arduino senden
	Next
	_SerialComm_SendData($hPort, Chr(4)) ; Ende der Uebertragung an den Arduino senden
	_SerialComm_ReceiveData($hPort, $tReceiveData) ; die Antwort vom Arduino empfangen
	_SerialComm_ClosePort($hPort)
	Return DllStructGetData($tReceiveData, 1)
EndFunc   ;==>_LCD_SendMail

Func _GetComPortNames()
	;funkey 2010, Nov 29th
	Local $objWMIService = ObjGet('winmgmts:\\localhost\root\CIMV2')
	Local $colItems = $objWMIService.ExecQuery('SELECT * FROM Win32_PnPEntity WHERE Name LIKE "%COM%" AND Service LIKE "%ser%"', 'WQL', 48) ; Oscar added: AND Service LIKE "%ser%"
	Local $sRet = ''
	For $objItem In $colItems
		$sRet &= $objItem.Name & @CR
	Next
	If $sRet = '' Then Return SetError(1, 0, '')
	Return StringSplit(StringTrimRight($sRet, 1), @CR, 2)
EndFunc   ;==>_GetComPortNames
